• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1# Example for use of GNU gettext.
2# This file is in the public domain.
3#
4# Makefile configuration - processed by automake.
5
6# List of files which contain translatable strings.
7POTFILES = \
8  hello-1.pl.in hello-2.pl.in
9
10# Usually the message domain is the same as the package name.
11DOMAIN = $(PACKAGE)
12
13# These options get passed to xgettext.
14XGETTEXT_OPTIONS = \
15  -k_ --flag=_:1:pass-perl-format --flag=_:1:pass-perl-brace-format \
16  -k__ --flag=__:1:pass-perl-format --flag=__:1:pass-perl-brace-format \
17  -k'$$__' --flag='$$__:1:pass-perl-format' --flag='$$__:1:pass-perl-brace-format' \
18  -k'%__' --flag=%__:1:pass-perl-format --flag=%__:1:pass-perl-brace-format \
19  -k__x --flag=__x:1:perl-brace-format \
20  -k__n:1,2 --flag=__n:1:pass-perl-format --flag=__n:1:pass-perl-brace-format \
21            --flag=__n:2:pass-perl-format --flag=__n:2:pass-perl-brace-format \
22  -k__nx:1,2 --flag=__nx:1:perl-brace-format --flag=__nx:2:perl-brace-format \
23  -k__xn:1,2 --flag=__xn:1:perl-brace-format --flag=__xn:2:perl-brace-format \
24  -kN__ --flag=N__:1:pass-perl-format --flag=N__:1:pass-perl-brace-format
25
26# This is the copyright holder that gets inserted into the header of the
27# $(DOMAIN).pot file.  Set this to the copyright holder of the surrounding
28# package.  (Note that the msgstr strings, extracted from the package's
29# sources, belong to the copyright holder of the package.)  Translators are
30# expected to transfer the copyright for their translations to this person
31# or entity, or to disclaim their copyright.  The empty string stands for
32# the public domain; in this case the translators are expected to disclaim
33# their copyright.
34COPYRIGHT_HOLDER = Yoyodyne, Inc.
35
36# This tells whether or not to prepend "GNU " prefix to the package
37# name that gets inserted into the header of the $(DOMAIN).pot file.
38# Possible values are "yes", "no", or empty.  If it is empty, try to
39# detect it automatically by scanning the files in $(top_srcdir) for
40# "GNU packagename" string.
41PACKAGE_GNU = no
42
43# This is the email address or URL to which the translators shall report
44# bugs in the untranslated strings:
45# - Strings which are not entire sentences, see the maintainer guidelines
46#   in the GNU gettext documentation, section 'Preparing Strings'.
47# - Strings which use unclear terms or require additional context to be
48#   understood.
49# - Strings which make invalid assumptions about notation of date, time or
50#   money.
51# - Pluralisation problems.
52# - Incorrect English spelling.
53# - Incorrect formatting.
54# It can be your email address, or a mailing list address where translators
55# can write to without being subscribed, or the URL of a web page through
56# which the translators can contact you.
57MSGID_BUGS_ADDRESS = bug-gettext@gnu.org
58
59# This is the list of locale categories, beyond LC_MESSAGES, for which the
60# message catalogs shall be used.  It is usually empty.
61EXTRA_LOCALE_CATEGORIES =
62
63# These options get passed to msgmerge.
64# Useful options are in particular:
65#   --previous            to keep previous msgids of translated messages,
66#   --quiet               to reduce the verbosity.
67MSGMERGE_OPTIONS = --quiet
68
69# These options get passed to msginit.
70# If you want to disable line wrapping when writing PO files, add
71# --no-wrap to MSGMERGE_OPTIONS, XGETTEXT_OPTIONS, and
72# MSGINIT_OPTIONS.
73MSGINIT_OPTIONS =
74
75MSGMERGE = @MSGMERGE@
76MSGMERGE_UPDATE = @MSGMERGE@ --update
77MSGMERGE_FOR_MSGFMT_OPTION = @MSGMERGE_FOR_MSGFMT_OPTION@
78MSGINIT = msginit
79MSGCONV = msgconv
80MSGFILTER = msgfilter
81
82# This is computed as $(foreach file, $(POTFILES), $(top_srcdir)/$(file))
83POTFILES_DEPS = @POTFILES_DEPS@
84
85# This is computed as $(foreach lang, $(LINGUAS), $(srcdir)/$(lang).po)
86POFILES = @POFILES@
87# This is computed as $(foreach lang, $(LINGUAS), $(srcdir)/$(lang).gmo)
88GMOFILES = @GMOFILES@
89# This is computed as $(foreach lang, $(LINGUAS), $(lang).po-update)
90UPDATEPOFILES = @UPDATEPOFILES@
91# This is computed as $(foreach lang, $(LINGUAS), $(lang).nop)
92DUMMYPOFILES = @DUMMYPOFILES@
93
94# This is computed as
95# $(foreach lang, user-specified subset of $(LINGUAS), $(lang).gmo)
96CATALOGS = @CATALOGS@
97
98SUFFIXES = .po .gmo .sed .sin .nop .po-create .po-update
99
100# The .pot file, stamp-po, .po files, and .gmo files appear in release tarballs.
101# The GNU Coding Standards say in
102# <https://www.gnu.org/prep/standards/html_node/Makefile-Basics.html>:
103#   "GNU distributions usually contain some files which are not source files
104#    ... . Since these files normally appear in the source directory, they
105#    should always appear in the source directory, not in the build directory.
106#    So Makefile rules to update them should put the updated files in the
107#    source directory."
108# Therefore we put these files in the source directory, not the build directory.
109
110# During .po -> .gmo conversion, take into account the most recent changes to
111# the .pot file. This eliminates the need to update the .po files when the
112# .pot file has changed, which would be troublesome if the .po files are put
113# under version control.
114$(GMOFILES): $(srcdir)/$(DOMAIN).pot
115.po.gmo:
116	@lang=`echo $* | sed -e 's,.*/,,'`; \
117	test "$(srcdir)" = . && cdcmd="" || cdcmd="cd $(srcdir) && "; \
118	echo "$${cdcmd}rm -f $${lang}.gmo && $(MSGMERGE) $(MSGMERGE_FOR_MSGFMT_OPTION) -o $${lang}.1po $${lang}.po $(DOMAIN).pot && $(GMSGFMT) -c --statistics --verbose -o $${lang}.gmo $${lang}.1po && rm -f $${lang}.1po"; \
119	cd $(srcdir) && \
120	rm -f $${lang}.gmo && \
121	$(MSGMERGE) $(MSGMERGE_FOR_MSGFMT_OPTION) -o $${lang}.1po $${lang}.po $(DOMAIN).pot && \
122	$(GMSGFMT) -c --statistics --verbose -o t-$${lang}.gmo $${lang}.1po && \
123	mv t-$${lang}.gmo $${lang}.gmo && \
124	rm -f $${lang}.1po
125
126.sin.sed:
127	sed -e '/^#/d' $< > t-$@
128	mv t-$@ $@
129
130
131all-local: all-local-@USE_NLS@
132
133all-local-yes: $(srcdir)/stamp-po
134all-local-no:
135
136# $(srcdir)/$(DOMAIN).pot is only created when needed. When xgettext finds no
137# internationalized messages, no $(srcdir)/$(DOMAIN).pot is created (because
138# we don't want to bother translators with empty POT files). We assume that
139# LINGUAS is empty in this case, i.e. $(POFILES) and $(GMOFILES) are empty.
140# In this case, $(srcdir)/stamp-po is a nop (i.e. a phony target).
141
142# $(srcdir)/stamp-po is a timestamp denoting the last time at which the CATALOGS
143# have been loosely updated. Its purpose is that when a developer or translator
144# checks out the package from a version control system, and the $(DOMAIN).pot
145# file is not under version control, "make" will update the $(DOMAIN).pot and
146# the $(CATALOGS), but subsequent invocations of "make" will do nothing. This
147# timestamp would not be necessary if updating the $(CATALOGS) would always
148# touch them; however, the rule for $(POFILES) has been designed to not touch
149# files that don't need to be changed.
150$(srcdir)/stamp-po: $(srcdir)/$(DOMAIN).pot
151	test ! -f $(srcdir)/$(DOMAIN).pot || \
152	  test -z "$(GMOFILES)" || $(MAKE) $(GMOFILES)
153	@test ! -f $(srcdir)/$(DOMAIN).pot || { \
154	  echo "touch $(srcdir)/stamp-po" && \
155	  echo timestamp > $(srcdir)/stamp-poT && \
156	  mv $(srcdir)/stamp-poT $(srcdir)/stamp-po; \
157	}
158
159# Note: Target 'all' must not depend on target '$(DOMAIN).pot-update',
160# otherwise packages like GCC can not be built if only parts of the source
161# have been downloaded.
162
163# This target rebuilds $(DOMAIN).pot; it is an expensive operation.
164# Note that $(DOMAIN).pot is not touched if it doesn't need to be changed.
165# The determination of whether the package xyz is a GNU one is based on the
166# heuristic whether some file in the top level directory mentions "GNU xyz".
167# If GNU 'find' is available, we avoid grepping through monster files.
168$(DOMAIN).pot-update: $(POTFILES_DEPS) remove-potcdate.sed
169	package_gnu="$(PACKAGE_GNU)"; \
170	test -n "$$package_gnu" || { \
171	  if { if (LC_ALL=C find --version) 2>/dev/null | grep GNU >/dev/null; then \
172	         LC_ALL=C find -L $(top_srcdir) -maxdepth 1 -type f -size -10000000c -exec grep -i 'GNU $(PACKAGE)' /dev/null '{}' ';' 2>/dev/null; \
173	       else \
174	         LC_ALL=C grep -i 'GNU $(PACKAGE)' $(top_srcdir)/* 2>/dev/null; \
175	       fi; \
176	     } | grep -v 'libtool:' >/dev/null; then \
177	     package_gnu=yes; \
178	   else \
179	     package_gnu=no; \
180	   fi; \
181	}; \
182	if test "$$package_gnu" = "yes"; then \
183	  package_prefix='GNU '; \
184	else \
185	  package_prefix=''; \
186	fi; \
187	if test -n '$(MSGID_BUGS_ADDRESS)'; then \
188	  msgid_bugs_address='$(MSGID_BUGS_ADDRESS)'; \
189	else \
190	  msgid_bugs_address='$(PACKAGE_BUGREPORT)'; \
191	fi; \
192	case `$(XGETTEXT) --version | sed 1q | sed -e 's,^[^0-9]*,,'` in \
193	  '' | 0.[0-9] | 0.[0-9].* | 0.1[0-5] | 0.1[0-5].* | 0.16 | 0.16.[0-1]*) \
194	    $(XGETTEXT) --default-domain=$(DOMAIN) --directory=$(top_srcdir) \
195	      --add-comments=TRANSLATORS: \
196	      --copyright-holder='$(COPYRIGHT_HOLDER)' \
197	      --msgid-bugs-address="$$msgid_bugs_address" \
198	      $(XGETTEXT_OPTIONS) @XGETTEXT_EXTRA_OPTIONS@ \
199	      $(POTFILES) \
200	    ;; \
201	  *) \
202	    $(XGETTEXT) --default-domain=$(DOMAIN) --directory=$(top_srcdir) \
203	      --add-comments=TRANSLATORS: \
204	      --copyright-holder='$(COPYRIGHT_HOLDER)' \
205	      --package-name="$${package_prefix}$(PACKAGE)" \
206	      --package-version='$(VERSION)' \
207	      --msgid-bugs-address="$$msgid_bugs_address" \
208	      $(XGETTEXT_OPTIONS) @XGETTEXT_EXTRA_OPTIONS@ \
209	      $(POTFILES) \
210	    ;; \
211	esac
212	test ! -f $(DOMAIN).po || { \
213	  if test -f $(srcdir)/$(DOMAIN).pot-header; then \
214	    sed -e '1,/^#$$/d' < $(DOMAIN).po > $(DOMAIN).1po && \
215	    cat $(srcdir)/$(DOMAIN).pot-header $(DOMAIN).1po > $(DOMAIN).po && \
216	    rm -f $(DOMAIN).1po \
217	    || exit 1; \
218	  fi; \
219	  if test -f $(srcdir)/$(DOMAIN).pot; then \
220	    sed -f remove-potcdate.sed < $(srcdir)/$(DOMAIN).pot > $(DOMAIN).1po && \
221	    sed -f remove-potcdate.sed < $(DOMAIN).po > $(DOMAIN).2po && \
222	    if cmp $(DOMAIN).1po $(DOMAIN).2po >/dev/null 2>&1; then \
223	      rm -f $(DOMAIN).1po $(DOMAIN).2po $(DOMAIN).po; \
224	    else \
225	      rm -f $(DOMAIN).1po $(DOMAIN).2po $(srcdir)/$(DOMAIN).pot && \
226	      mv $(DOMAIN).po $(srcdir)/$(DOMAIN).pot; \
227	    fi; \
228	  else \
229	    mv $(DOMAIN).po $(srcdir)/$(DOMAIN).pot; \
230	  fi; \
231	}
232
233# This rule has no dependencies: we don't need to update $(DOMAIN).pot at
234# every "make" invocation, only create it when it is missing.
235# Only "make $(DOMAIN).pot-update" or "make dist" will force an update.
236$(srcdir)/$(DOMAIN).pot:
237	$(MAKE) $(DOMAIN).pot-update
238
239# This target rebuilds a PO file if $(DOMAIN).pot has changed.
240# Note that a PO file is not touched if it doesn't need to be changed.
241$(POFILES): $(srcdir)/$(DOMAIN).pot
242	@lang=`echo $@ | sed -e 's,.*/,,' -e 's/\.po$$//'`; \
243	if test -f "$(srcdir)/$${lang}.po"; then \
244	  test "$(srcdir)" = . && cdcmd="" || cdcmd="cd $(srcdir) && "; \
245	  echo "$${cdcmd}$(MSGMERGE_UPDATE) $(MSGMERGE_OPTIONS) --lang=$${lang} --previous $${lang}.po $(DOMAIN).pot"; \
246	  cd $(srcdir) \
247	    && { case `$(MSGMERGE_UPDATE) --version | sed 1q | sed -e 's,^[^0-9]*,,'` in \
248	           '' | 0.[0-9] | 0.[0-9].* | 0.1[0-5] | 0.1[0-5].*) \
249	             $(MSGMERGE_UPDATE) $(MSGMERGE_OPTIONS) $${lang}.po $(DOMAIN).pot;; \
250	           0.1[6-7] | 0.1[6-7].*) \
251	             $(MSGMERGE_UPDATE) $(MSGMERGE_OPTIONS) --previous $${lang}.po $(DOMAIN).pot;; \
252	           *) \
253	             $(MSGMERGE_UPDATE) $(MSGMERGE_OPTIONS) --lang=$${lang} --previous $${lang}.po $(DOMAIN).pot;; \
254	         esac; \
255	       }; \
256	else \
257	  $(MAKE) $${lang}.po-create; \
258	fi
259
260
261install-data-local: install-data-local-@USE_NLS@
262install-data-local-no: all-local
263install-data-local-yes: all-local
264	@catalogs='$(CATALOGS)'; \
265	for cat in $$catalogs; do \
266	  cat=`basename $$cat`; \
267	  lang=`echo $$cat | sed -e 's/\.gmo$$//'`; \
268	  dir=$(localedir)/$$lang/LC_MESSAGES; \
269	  $(MKDIR_P) $(DESTDIR)$$dir; \
270	  if test -r $$cat; then realcat=$$cat; else realcat=$(srcdir)/$$cat; fi; \
271	  $(INSTALL_DATA) $$realcat $(DESTDIR)$$dir/$(DOMAIN).mo; \
272	  echo "installing $$realcat as $(DESTDIR)$$dir/$(DOMAIN).mo"; \
273	  for lc in '' $(EXTRA_LOCALE_CATEGORIES); do \
274	    if test -n "$$lc"; then \
275	      if (cd $(DESTDIR)$(localedir)/$$lang && LC_ALL=C ls -l -d $$lc 2>/dev/null) | grep ' -> ' >/dev/null; then \
276	        link=`cd $(DESTDIR)$(localedir)/$$lang && LC_ALL=C ls -l -d $$lc | sed -e 's/^.* -> //'`; \
277	        mv $(DESTDIR)$(localedir)/$$lang/$$lc $(DESTDIR)$(localedir)/$$lang/$$lc.old; \
278	        mkdir $(DESTDIR)$(localedir)/$$lang/$$lc; \
279	        (cd $(DESTDIR)$(localedir)/$$lang/$$lc.old && \
280	         for file in *; do \
281	           if test -f $$file; then \
282	             ln -s ../$$link/$$file $(DESTDIR)$(localedir)/$$lang/$$lc/$$file; \
283	           fi; \
284	         done); \
285	        rm -f $(DESTDIR)$(localedir)/$$lang/$$lc.old; \
286	      else \
287	        if test -d $(DESTDIR)$(localedir)/$$lang/$$lc; then \
288	          :; \
289	        else \
290	          rm -f $(DESTDIR)$(localedir)/$$lang/$$lc; \
291	          mkdir $(DESTDIR)$(localedir)/$$lang/$$lc; \
292	        fi; \
293	      fi; \
294	      rm -f $(DESTDIR)$(localedir)/$$lang/$$lc/$(DOMAIN).mo; \
295	      ln -s ../LC_MESSAGES/$(DOMAIN).mo $(DESTDIR)$(localedir)/$$lang/$$lc/$(DOMAIN).mo 2>/dev/null || \
296	      ln $(DESTDIR)$(localedir)/$$lang/LC_MESSAGES/$(DOMAIN).mo $(DESTDIR)$(localedir)/$$lang/$$lc/$(DOMAIN).mo 2>/dev/null || \
297	      cp -p $(DESTDIR)$(localedir)/$$lang/LC_MESSAGES/$(DOMAIN).mo $(DESTDIR)$(localedir)/$$lang/$$lc/$(DOMAIN).mo; \
298	      echo "installing $$realcat link as $(DESTDIR)$(localedir)/$$lang/$$lc/$(DOMAIN).mo"; \
299	    fi; \
300	  done; \
301	done
302
303installdirs-local: installdirs-local-@USE_NLS@
304installdirs-local-no:
305installdirs-local-yes:
306	@catalogs='$(CATALOGS)'; \
307	for cat in $$catalogs; do \
308	  cat=`basename $$cat`; \
309	  lang=`echo $$cat | sed -e 's/\.gmo$$//'`; \
310	  dir=$(localedir)/$$lang/LC_MESSAGES; \
311	  $(MKDIR_P) $(DESTDIR)$$dir; \
312	  for lc in '' $(EXTRA_LOCALE_CATEGORIES); do \
313	    if test -n "$$lc"; then \
314	      if (cd $(DESTDIR)$(localedir)/$$lang && LC_ALL=C ls -l -d $$lc 2>/dev/null) | grep ' -> ' >/dev/null; then \
315	        link=`cd $(DESTDIR)$(localedir)/$$lang && LC_ALL=C ls -l -d $$lc | sed -e 's/^.* -> //'`; \
316	        mv $(DESTDIR)$(localedir)/$$lang/$$lc $(DESTDIR)$(localedir)/$$lang/$$lc.old; \
317	        mkdir $(DESTDIR)$(localedir)/$$lang/$$lc; \
318	        (cd $(DESTDIR)$(localedir)/$$lang/$$lc.old && \
319	         for file in *; do \
320	           if test -f $$file; then \
321	             ln -s ../$$link/$$file $(DESTDIR)$(localedir)/$$lang/$$lc/$$file; \
322	           fi; \
323	         done); \
324	        rm -f $(DESTDIR)$(localedir)/$$lang/$$lc.old; \
325	      else \
326	        if test -d $(DESTDIR)$(localedir)/$$lang/$$lc; then \
327	          :; \
328	        else \
329	          rm -f $(DESTDIR)$(localedir)/$$lang/$$lc; \
330	          mkdir $(DESTDIR)$(localedir)/$$lang/$$lc; \
331	        fi; \
332	      fi; \
333	    fi; \
334	  done; \
335	done
336
337uninstall-local: uninstall-local-@USE_NLS@
338uninstall-local-no:
339uninstall-local-yes:
340	catalogs='$(CATALOGS)'; \
341	for cat in $$catalogs; do \
342	  cat=`basename $$cat`; \
343	  lang=`echo $$cat | sed -e 's/\.gmo$$//'`; \
344	  for lc in LC_MESSAGES $(EXTRA_LOCALE_CATEGORIES); do \
345	    rm -f $(DESTDIR)$(localedir)/$$lang/$$lc/$(DOMAIN).mo; \
346	  done; \
347	done
348
349html ID:
350
351MOSTLYCLEANFILES =
352MOSTLYCLEANFILES += remove-potcdate.sed
353MOSTLYCLEANFILES += stamp-poT
354MOSTLYCLEANFILES += core core.* *.stackdump $(DOMAIN).po $(DOMAIN).1po $(DOMAIN).2po *.new.po
355MOSTLYCLEANFILES += *.o
356
357MAINTAINERCLEANFILES = $(DOMAIN).pot stamp-po $(GMOFILES)
358
359EXTRA_DIST = remove-potcdate.sin LINGUAS $(POFILES) $(GMOFILES)
360
361# Hidden from automake, but really activated. Works around an automake-1.5 bug.
362#distdir: distdir1
363distdir1:
364	$(MAKE) update-po
365	$(MAKE) $(srcdir)/stamp-po
366	@if test -f $(srcdir)/$(DOMAIN).pot; then \
367	  for file in $(DOMAIN).pot stamp-po; do \
368	    if test -f $$file; then d=.; else d=$(srcdir); fi; \
369	    cp -p $$d/$$file $(distdir)/$$file || exit 1; \
370	  done; \
371	else \
372	  case $(XGETTEXT) in \
373	    :) echo "Warning: Creating a tarball without '$(DOMAIN).pot', because a suitable 'xgettext' program was not found in PATH." 1>&2;; \
374	    *) echo "Warning: Creating a tarball without '$(DOMAIN).pot', because 'xgettext' found no strings to extract. Check the POTFILES and the XGETTEXT_OPTIONS in the Makefile.am file." 1>&2;; \
375	  esac; \
376	fi
377
378update-po: Makefile
379	$(MAKE) $(DOMAIN).pot-update
380	test -z "$(UPDATEPOFILES)" || $(MAKE) $(UPDATEPOFILES)
381	$(MAKE) update-gmo
382
383# General rule for creating PO files.
384
385.nop.po-create:
386	@lang=`echo $@ | sed -e 's/\.po-create$$//'`; \
387	echo "File $$lang.po does not exist. If you are a translator, you can create it through 'msginit'." 1>&2; \
388	exit 1
389
390# General rule for updating PO files.
391
392.nop.po-update:
393	@lang=`echo $@ | sed -e 's/\.po-update$$//'`; \
394	tmpdir=`pwd`; \
395	echo "$$lang:"; \
396	test "$(srcdir)" = . && cdcmd="" || cdcmd="cd $(srcdir) && "; \
397	echo "$${cdcmd}$(MSGMERGE) $(MSGMERGE_OPTIONS) --lang=$$lang --previous $$lang.po $(DOMAIN).pot -o $$lang.new.po"; \
398	cd $(srcdir); \
399	if { case `$(MSGMERGE) --version | sed 1q | sed -e 's,^[^0-9]*,,'` in \
400	       '' | 0.[0-9] | 0.[0-9].* | 0.1[0-5] | 0.1[0-5].*) \
401	         $(MSGMERGE) $(MSGMERGE_OPTIONS) -o $$tmpdir/$$lang.new.po $$lang.po $(DOMAIN).pot;; \
402	       0.1[6-7] | 0.1[6-7].*) \
403	         $(MSGMERGE) $(MSGMERGE_OPTIONS) --previous -o $$tmpdir/$$lang.new.po $$lang.po $(DOMAIN).pot;; \
404	       *) \
405	         $(MSGMERGE) $(MSGMERGE_OPTIONS) --lang=$$lang --previous -o $$tmpdir/$$lang.new.po $$lang.po $(DOMAIN).pot;; \
406	     esac; \
407	   }; then \
408	  if cmp $$lang.po $$tmpdir/$$lang.new.po >/dev/null 2>&1; then \
409	    rm -f $$tmpdir/$$lang.new.po; \
410	  else \
411	    if mv -f $$tmpdir/$$lang.new.po $$lang.po; then \
412	      :; \
413	    else \
414	      echo "msgmerge for $$lang.po failed: cannot move $$tmpdir/$$lang.new.po to $$lang.po" 1>&2; \
415	      exit 1; \
416	    fi; \
417	  fi; \
418	else \
419	  echo "msgmerge for $$lang.po failed!" 1>&2; \
420	  rm -f $$tmpdir/$$lang.new.po; \
421	fi
422
423$(DUMMYPOFILES):
424
425update-gmo: Makefile $(GMOFILES)
426	@:
427